;*************************************************************************
; Copyright (c) 2002 The University of Chicago, as Operator of Argonne
; National Laboratory.
; Copyright (c) 2002 The Regents of the University of California, as
; Operator of Los Alamos National Laboratory.
; This file is distributed subject to a Software License Agreement found
; in the file LICENSE that is included with this distribution. 
;*************************************************************************
;*********************  Edits  ************************
;
; 03/30/98  nda  Added parameter scanLines
; 08/13/98  nda  Swapped Variable1Name and Variable2Name such that now
;                Variable1Name = 'y' and Variable2Name = 'x'
;

PRO writeSDDSimage, filename
                    
   COMMON CATCH_IMAGE, widget_ids, imageData

   srcNames = ['Raw', 'Bkgnd', 'Raw-Bkgnd']
   rotNames = ['0', '90', '180', '270']
   WIDGET_CONTROL, widget_ids.info_block, GET_VALUE = comment
   WIDGET_CONTROL, widget_ids.snapFile, GET_VALUE = snapFile

   OPENW, lun, filename, /Get_LUN, Error = err

   IF (err EQ 0) THEN BEGIN
       printf, lun, 'SDDS1'
       printf, lun, '&description'
       printf, lun, ' text = "' + comment + '", contents = "IDL Image", &end'
       printf, lun, '&parameter'
       printf, lun, ' name = Variable1Name,  type = string, &end'
       printf, lun, '&parameter'
       printf, lun, ' name = Variable2Name,  type = string, &end'
       printf, lun, '&parameter'
       printf, lun, ' name = Comment,  type = string, &end'
       printf, lun, '&parameter'
       printf, lun, ' name = ScreenID,  type = string, &end'
       printf, lun, '&parameter'
       printf, lun, ' name = ImageType,  type = string, &end'
       printf, lun, '&parameter'
       printf, lun, ' name = SnapFile,  type = string, &end'
       printf, lun, '&parameter'
       printf, lun, ' name = RotationDesc,  type = string, &end'
       printf, lun, '&parameter'
       printf, lun, ' name = scanLines, type = short, &end'
       printf, lun, '&parameter'
       printf, lun, ' name = CalType, type = short, &end'
       printf, lun, '&parameter'
       printf, lun, ' name = Calibrated, type = short, &end'
       printf, lun, '&parameter'
       printf, lun, ' name = Rotation,  type = short, &end'
       printf, lun, '&parameter'
       printf, lun, ' name = XminRoi,  type = short, &end'
       printf, lun, '&parameter'
       printf, lun, ' name = XmaxRoi,  type = short, &end'
       printf, lun, '&parameter'
       printf, lun, ' name = YminRoi,  type = short, &end'
       printf, lun, '&parameter'
       printf, lun, ' name = YmaxRoi,  type = short, &end'
       printf, lun, '&parameter'
       printf, lun, ' name = CalXminPix,  type = short, &end'
       printf, lun, '&parameter'
       printf, lun, ' name = CalXmaxPix,  type = short, &end'
       printf, lun, '&parameter'
       printf, lun, ' name = CalYminPix,  type = short, &end'
       printf, lun, '&parameter'
       printf, lun, ' name = CalYmaxPix,  type = short, &end'
       printf, lun, '&parameter'
       printf, lun, ' name = CalXminEgu,  type = double, &end'
       printf, lun, '&parameter'
       printf, lun, ' name = CalXmaxEgu,  type = double, &end'
       printf, lun, '&parameter'
       printf, lun, ' name = CalYminEgu,  type = double, &end'
       printf, lun, '&parameter'
       printf, lun, ' name = CalYmaxEgu,  type = double, &end'
       printf, lun, '&parameter'
       printf, lun, ' name = Xsigma,  type = double, &end'
       printf, lun, '&parameter'
       printf, lun, ' name = Xcenter, type = double, &end'
       printf, lun, '&parameter'
       printf, lun, ' name = Xpeak, type = double, &end'
       printf, lun, '&parameter'
       printf, lun, ' name = Ysigma,  type = double, &end'
       printf, lun, '&parameter'
       printf, lun, ' name = Ycenter, type = double, &end'
       printf, lun, '&parameter'
       printf, lun, ' name = Ypeak, type = double, &end'
       printf, lun, '&parameter'
       printf, lun, ' name = xInterval,  type = double, &end'
       printf, lun, '&parameter'
       printf, lun, ' name = xMinimum,  type = double, &end'
       printf, lun, '&parameter'
       printf, lun, ' name = xDimension,  type = long, &end'
       printf, lun, '&parameter'
       printf, lun, ' name = yInterval,  type = double, &end'
       printf, lun, '&parameter'
       printf, lun, ' name = yMinimum,  type = double, &end'
       printf, lun, '&parameter'
       printf, lun, ' name = yDimension,  type = long, &end'
       printf, lun, '&parameter'
       printf, lun, ' name = NumberOfColumns,  type = long, &end'
       printf, lun, '&parameter'
       printf, lun, ' name = NumberOfRows,  type = long, &end'
       printf, lun, '&column'
       printf, lun, ' name = Intensity,  type = short, &end'
       printf, lun, '&data'
       printf, lun, ' mode = ascii, &end'

       printf, lun, 'y'
       printf, lun, 'x'
       printf, lun, comment
       printf, lun, imageData.cal.desc
       printf, lun, srcNames[imageData.plotSrc]
       printf, lun, snapFile
       printf, lun, rotNames[imageData.cal.rotation]
       printf, lun, imageData.lines
       printf, lun, '0'   ; square cal box
       printf, lun, imageData.cal.calibrated
       printf, lun, imageData.cal.rotation
       printf, lun, imageData.cal.xmin_ROI
       printf, lun, imageData.cal.xmax_ROI
       printf, lun, imageData.cal.ymin_ROI
       printf, lun, imageData.cal.ymax_ROI
       printf, lun, imageData.cal.xmin_PIX
       printf, lun, imageData.cal.xmax_PIX
       printf, lun, imageData.cal.ymin_PIX
       printf, lun, imageData.cal.ymax_PIX
       printf, lun, imageData.cal.xmin_EGU
       printf, lun, imageData.cal.xmax_EGU
       printf, lun, imageData.cal.ymin_EGU
       printf, lun, imageData.cal.ymax_EGU
       printf, lun, imageData.xp_sigma
       printf, lun, imageData.xp_center
       printf, lun, imageData.xp_peak
       printf, lun, imageData.yp_sigma
       printf, lun, imageData.yp_center
       printf, lun, imageData.yp_peak
       printf, lun, imageData.xGain
       printf, lun, imageData.xOffset
       printf, lun, imageData.xsize
       printf, lun, imageData.yGain
       printf, lun, imageData.yOffset
       printf, lun, imageData.ysize

       printf, lun, imageData.xsize
       printf, lun, imageData.ysize

       printf, lun, LONG(imageData.xsize)*LONG(imageData.ysize)
       printf, lun, imageData.plotImage, FORMAT = '(I)'
       Free_LUN, lun
   ENDIF ELSE BEGIN
       result = WIDGET_MESSAGE("FILE WRITE ERROR !")
   ENDELSE
   RETURN

END
